 
.386
.MODEL FLAT
INCLUDE io.h

ExitProcess PROTO NEAR32 stdcall, dwExitCode: DWORD

cr                EQU    0dh                                 ; carriage return character
Lf                EQU    0ah                                 ; linefeed character
maxNbrs    EQU    100                                 ;size of array

.STACK  4096                                              ; reserve 4096-byte stack

.DATA                                                            ; reserve storage for data


explain               BYTE               cr,Lf,"This program will find and display",cr,Lf
                           BYTE                "the first 100 prime numbers",cr,Lf

nbrArray             DWORD          maxNbrs DUP (?)  , cr, Lf, 0  
primeCount        DWORD          ?
candidate           DWORD          ?
index                  DWORD          ?
displayIndex      DWORD          ?
endNumLabel    BYTE              cr, Lf, "Prime numbers: "
outValue             BYTE               ?  
newLine              BYTE               cr, Lf

.CODE                                                            ; start of main program code
_start: 
                              output explain                   ; initial instructions\
                               lea    ebx, nbrArray     
                               mov    eax, 2                    ; first two prime numbers
                               mov     [ebx], eax 
                               add     ebx, 4
                               mov    eax, 3
                               mov    [ebx], eax               ;   ""                             
                               mov    primeCount, 2       ; primeCount := 2
                               mov    ecx, primeCount
                               mov    candidate, 4          ;  next number to test as prime
  
whilePrimeCount:  cmp   ecx, 100                ; primeCount < 100?
                               jge     endMain                 ;end if 100 primes   
                               mov   index, 1

                               lea     ebx, nbrArray       
   
                                                        ;     test current prime
                               mov   eax, candidate
nextPrime:             cdq  
                               idiv     ebx                         ;  and get next prime if prime/candidate  
                               cmp   edx, 0                     ;  is there a remainder?
                               je       incCandidate          ; if not, increment the candidate
                               cmp   index, ecx              ;
                               jg       storePrime             ;   Test index > ecx
                               jmp    nextPrime2
nextPrime2:                               
                               add    index, 1
                               add    ebx, 4
                               jmp    nextPrime
                         ;   ---   ??   ---          
incCandidate:        add    eax, 1        ; get next number to test
                               jmp    whilePrimeCount     ; jmp beginning of process

storePrime:                                                        ; store candidate in array
                               mov    [ebx], eax                 ;
                               add     ecx, 1                       ; inc primeCount
                               jmp     whilePrimeCount     ; jmp beginning of process
                                                                                                      
endMain:                lea ebx, nbrArray               
                               mov ecx, 100                     ; mov 100 to ecx for loop
                               mov displayIndex, 1          
                               output endNumLabel         ; output
                               dtoa   outValue,[ebx] 
                               output outValue
             
display:                   cmp displayIndex, 5
                                jg     newLineLoop
                                cmp ecx, 0
                                je     quit                              ;exit if 100 primes have been displayed
                                add  ebx, 4                         ;get next item of array
                                dtoa   outValue,[ebx]         ;convert to integer
                 
                                output outValue
                                add displayIndex, 1
                                loop display                        ;loop until ecx = 0

newLineLoop:        output newLine
                                mov displayIndex, 1
                                jmp display
 
quit:                         INVOKE ExitProcess, 0    ;exit with return code 0

PUBLIC _start                                                    ; make entry point public
            END
